﻿using System;
using System.Management;

namespace TestProject
{
    /// <summary>
    /// 프로그램
    /// </summary>
    class Program
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region 프로그램 시작하기 - Main(argumentArray)

        /// <summary>
        /// 프로그램 시작하기
        /// </summary>
        /// <param name="argumentArray">인자 배열</param>
        private static void Main(string[] argumentArray)
        {
            Console.Title = "ManagementClass 클래스 : 컴퓨터 타입 구하기";

            ComputerType computerType = GetComputerType();

            Console.WriteLine($"컴퓨터 타입 : {computerType}");
        }

        #endregion

        #region 컴퓨터 타입 구하기 - GetComputerType()

        /// <summary>
        /// 컴퓨터 타입 구하기
        /// </summary>
        /// <returns>컴퓨터 타입</returns>
        private static ComputerType GetComputerType()
        {
            try
            {
                ManagementClass managementClass = new ManagementClass("Win32_SystemEnclosure");
                
                foreach(ManagementObject managementObject in managementClass.GetInstances())
                {
                    foreach(int index in (ushort[])managementObject.GetPropertyValue("ChassisTypes"))
                    {
                        return (ComputerType)index;
                    }
                }
                
                return ComputerType.Unknown;
            }
            catch
            {
                return ComputerType.Unknown;
            }
        }

        #endregion
    }
}